const __addressHex = "%1$s";
const __rpcURL = "%2$s";
const __chainID = "%3$s";

function executeCallback (id, error, value) {
  AlphaWallet.executeCallback(id, error, value)
}

window.AlphaWallet.init(__rpcURL, {
eth_requestAccounts:function(){
console.debug('AlphaWallet eth_requestAccounts')
    return new Promise(function(resolve, reject) {})
},
requestAccounts:function(){
console.debug('AlphaWallet requestAccounts')
    return new Promise(function(resolve, reject) {})
},
  getAccounts: function (cb) {
  console.debug('AlphaWallet getAccounts')
   cb(null, [__addressHex])
   },
  processTransaction: function (tx, cb){
    console.debug('AlphaWallet signing a transaction', tx)
    const { id = 8888 } = tx
    AlphaWallet.addCallback(id, cb)
    var gasLimit = tx.gasLimit || tx.gas || null;
    var gasPrice = tx.gasPrice || null;
    var data = tx.data || null;
    var nonce = tx.nonce || -1;
    defigram.signTransaction(id, tx.to || null, tx.value, nonce, gasLimit, gasPrice, data);
  },
  signMessage: function (msgParams, cb) {
    const { data } = msgParams
    const { id = 8888 } = msgParams
    console.debug("AlphaWallet signing a message", msgParams)
    AlphaWallet.addCallback(id, cb)
    defigram.signMessage(id, data);
  },
  signPersonalMessage: function (msgParams, cb) {
    const { data } = msgParams
    const { id = 8888 } = msgParams
    console.debug("AlphaWallet signing a personal message", msgParams)
    AlphaWallet.addCallback(id, cb)
    defigram.signPersonalMessage(id, data);
  },
  signTypedMessage: function (msgParams, cb) {
    const { data } = msgParams
    const { id = 8888 } = msgParams
     console.debug('AlphaWallet - signTypedMessage')
    AlphaWallet.addCallback(id, cb)
    defigram.signTypedMessage(id, JSON.stringify(data))
  },
  walletAddEthereumChain: function (msgParams, cb) {
   console.debug('AlphaWallet - walletAddEthereumChain')
      const data = msgParams
      const { id = Math.floor((Math.random() * 100000) + 1) } = msgParams
      console.log("walletAddEthereumChain", msgParams)
      AlphaWallet.addCallback(id, cb)
      defigram.walletAddEthereumChain(id, JSON.stringify(msgParams));
      //webkit.messageHandlers.walletAddEthereumChain.postMessage({"name": "walletAddEthereumChain", "object": data, id: id})
    },
   ethCall: function (msgParams, cb) {
       console.log("eth_call", msgParams)
       const data = msgParams
       const { id = Math.floor((Math.random() * 100000) + 1) } = msgParams
       AlphaWallet.addCallback(id, cb)
       //alpha.ethCall(id, JSON.stringify(msgParams));
       defigram.ethCall(id, msgParams.to, msgParams.data);
     },
    enable: function() {
        return new Promise(function(resolve, reject) {
        console.debug('AlphaWallet Wallet - enable')
        var r=confirm("Confirm to make your wallet address public to this site?");
        if (r==true){
            resolve([__addressHex])
        }else{
            reject()
        }})
    }
}, {
    address: __addressHex,
    networkVersion: __chainID
})

window.web3.setProvider = function () {
 /*   const provider = new AlphaWallet({
      address: __addressHex,
      chainId: __chainID,
      rpcUrl: __rpcURL
    });
    window.web3.currentProvider = provider;*/
    console.debug('Alpha Wallet - overrode web3.setProvider')
}


window.web3.version.getNetwork = function(cb) {
console.debug('AlphaWallet Wallet - getNetwork')
    cb(null, __chainID)
}
window.web3.eth.getCoinbase = function(cb) {
console.debug('AlphaWallet Wallet - getCoinbase')
    return cb(null, __addressHex)
}

window.web3.eth.defaultAccount = __addressHex

console.debug('AlphaWallet Wallet - addressHex'+window.web3.eth.defaultAccount)

window.ctxWeb3 = new Web3(window.web3.currentProvider);
window.ctxWeb3.eth.defaultAccount = window.web3.eth.defaultAccount;

window.ethereum = web3.currentProvider;
console.log('AlphaWallet Wallet - ethereum'+web3.currentProvider)